Notes in EJ2 TypeScript Spreadsheet control

28 Jul 202624 minutes to read

The Notes feature is used to insert comments, provide feedback, suggest changes, and leave remarks on specific cells while reviewing documents in the Spreadsheet. You can enable or disable the notes functionality using the enableNotes property, which defaults to true.

When opening the Excel document with notes in the Spreadsheet, they will be displayed in the control. The cells containing notes will be indicated with a red colored triangle at the top-right corner. Hovering the mouse over these cells will display the content of the notes.

Adding, editing, and deleting a note in Spreadsheet

In the below example, you can add, edit, save, and delete notes.

import { Spreadsheet } from '@syncfusion/ej2-spreadsheet';

let sheet: SheetModel[] = [
    {
      ranges: [
        {
          dataSource: [
            {
              'Item Name': 'Casual Shoes',
              Date: '02/14/2014',
              Time: '11:34:32 AM',
              Quantity: 10,
              Price: 20,
              Amount: 200,
              Discount: 1,
              Profit: 10,
            },
            {
              'Item Name': 'Sports Shoes',
              Date: '06/11/2014',
              Time: '05:56:32 AM',
              Quantity: 20,
              Price: 30,
              Amount: 600,
              Discount: 5,
              Profit: 50,
            },
            {
              'Item Name': 'Formal Shoes',
              Date: '07/27/2014',
              Time: '03:32:44 AM',
              Quantity: 20,
              Price: 15,
              Amount: 300,
              Discount: 7,
              Profit: 27,
            },
            {
              'Item Name': 'Sandals & Floaters',
              Date: '11/21/2014',
              Time: '06:23:54 AM',
              Quantity: 15,
              Price: 20,
              Amount: 300,
              Discount: 11,
              Profit: 67,
            },
            {
              'Item Name': 'Flip- Flops & Slippers',
              Date: '06/23/2014',
              Time: '12:43:59 AM',
              Quantity: 30,
              Price: 10,
              Amount: 300,
              Discount: 10,
              Profit: 70,
            },
            {
              'Item Name': 'Sneakers',
              Date: '07/22/2014',
              Time: '10:55:53 AM',
              Quantity: 40,
              Price: 20,
              Amount: 800,
              Discount: 13,
              Profit: 66,
            },
            {
              'Item Name': 'Running Shoes',
              Date: '02/04/2014',
              Time: '03:44:34 AM',
              Quantity: 20,
              Price: 10,
              Amount: 200,
              Discount: 3,
              Profit: 14,
            },
            {
              'Item Name': 'Loafers',
              Date: '11/30/2014',
              Time: '03:12:52 AM',
              Quantity: 31,
              Price: 10,
              Amount: 310,
              Discount: 6,
              Profit: 29,
            },
            {
              'Item Name': 'Cricket Shoes',
              Date: '07/09/2014',
              Time: '11:32:14 AM',
              Quantity: 41,
              Price: 30,
              Amount: 1210,
              Discount: 12,
              Profit: 166,
            },
            {
              'Item Name': 'T-Shirts',
              Date: '10/31/2014',
              Time: '12:01:44 AM',
              Quantity: 50,
              Price: 10,
              Amount: 500,
              Discount: 9,
              Profit: 55,
            },
          ],
          startCell: 'A1',
        },
      ],
      rowCount: 200,
      columns: [
        {
          width: 130,
        },
        {
          width: 92,
        },
        {
          width: 96,
        },
      ],
    },
  ];

let spreadsheet: Spreadsheet = new Spreadsheet({
  sheets: sheet,
  allowOpen: true,
  openUrl: 'https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/open',
  allowSave: true,
  saveUrl: 'https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/save',
  created: function (): void {
    spreadsheet.cellFormat({ fontWeight: 'bold' }, 'A1:H1');
  }
});
spreadsheet.appendTo('#spreadsheet');
<!DOCTYPE html>
<html lang="en">

<head>
        <title>EJ2 SpreadSheet</title>
        <meta charset="utf-8" />
        <meta name="viewport" content="width=device-width, initial-scale=1.0" />
        <meta name="description" content="Typescript UI Controls" />
        <meta name="author" content="Syncfusion" />
        <link rel="shortcut icon" href="resources/favicon.ico" />
        <link href="https://cdn.syncfusion.com/ej2/33.1.44/tailwind3.css" rel="stylesheet" />
        <link href="https://cdn.syncfusion.com/ej2/33.1.44/ej2-base/styles/tailwind3.css" rel="stylesheet">
        <link href="https://cdn.syncfusion.com/ej2/33.1.44/ej2-grids/styles/tailwind3.css" rel="stylesheet">
        <link href="https://cdn.syncfusion.com/ej2/33.1.44/ej2-spreadsheet/styles/tailwind3.css" rel="stylesheet">
        <link href="styles.css" rel="stylesheet" />
        <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
        <script src="https://cdnjs.cloudflare.com/ajax/libs/core-js/2.4.1/shim.min.js"></script>
        <script src="system.config.js"></script>

<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
       <!--Element which is going to render-->
       <div id='loader'>Loading....</div>
       <div id='container'>
       <div id="spreadsheet"></div>
       </div>
</body>

</html>

Adding a note

In the active worksheet, you can add a note in the following ways:

  • Context Menu: Right-click the desired cell and select Add Note.
  • Ribbon: Select the cell, navigate to the Review tab, click the Notes dropdown, and select Add Note.
  • Keyboard Shortcut: Select the cell and press Shift + F2.
  • Programmatically:
    • Use the updateCell method with the note model to add a note to a specific cell.
    • Bind notes via code-behind during initial load by associating the note model with the cell model.

A dialog box will open where you can enter the note content. After entering the content, you can either click on other cells or press the Esc button to automatically save the note and close the dialog box.

Editing a note

In the active worksheet, you can modify the content of existing notes in the document:

  • Context Menu: Right-click the cell containing the note and select Edit Note.
  • Ribbon: Select the cell containing the note, navigate to the Review tab, click the Notes dropdown, and select Edit Note.
  • Keyboard Shortcut: Select the cell containing the note and press Shift + F2.

The note editor dialog box will open with the existing content. After editing the content, you can either click on other cells or press the Esc button to automatically save the changes and close the dialog box.

Deleting a note

You can remove notes from cells using the following ways:

  • Context Menu: Right-click the cell containing the note and select Delete Note.
  • Ribbon: Select the cell containing the note, navigate to the Review tab, click the Notes dropdown, and select Delete Note.

The note will be removed from the cell, and the red triangle indicator will be removed.

Navigating between notes in Spreadsheet

The Syncfusion Spreadsheet provides intuitive navigation to quickly move between cells containing notes in your worksheet. These options are accessible through the Notes dropdown in the Review tab.

Previous Note

To navigate to the previous note:

  • In the Review tab, open the Notes dropdown and select Previous Note.
  • The Spreadsheet will automatically select the previous note in the current worksheet, searching leftward and then upward.
  • If no prior note exists in the sheet, the search continues to the previous worksheet in order.
  • If the workbook contains no notes, the selection remains on the current cell.

Next Note

To navigate to the next note:

  • In the Review tab, open the Notes dropdown and select Next Note.
  • The Spreadsheet will automatically select the next note in the current worksheet, searching rightward and then downward.
  • If no subsequent note exists in the sheet, the search continues to the next worksheet in order.
  • If the workbook contains no notes, the selection remains on the current cell.

This functionality streamlines the process of reviewing notes across worksheets, ensuring efficient traversal and discovery.

Show/Hide Note

The Show/Hide Note option allows you to toggle the visibility of individual notes as sticky notes within the worksheet. When enabled, the note appears as a persistent floating text box, making it convenient to reference key information without hovering over the cell.

To toggle the visibility of a note:

  • Context Menu: Right-click the cell containing the note and select Show/Hide Note.
  • Ribbon: Select the cell, go to the Review tab, click the Notes dropdown, and choose Show/Hide Note.

Behavior:

  • Default State (Hidden): Notes are hidden by default and only appear when hovering over the cell, which displays a red triangle indicator.
  • Sticky State (Visible): Toggling Show/Hide Note on a hidden note makes it visible as a sticky note, which remains on display even when navigating to other cells or selections.
  • Toggle Functionality: Selecting Show/Hide Note again on a visible note hides it, reverting to the default state.
  • Independent Control: Each note can be toggled individually, allowing you to display only the most relevant notes for your current task.

Show All Notes

The Show All Notes option displays all notes in the current worksheet simultaneously as sticky notes. This simplifies reviewing multiple comments at a glance.

To activate:

  • Navigate to the Review tab, click the Notes dropdown, and select Show All Notes.

All notes in the worksheet will appear as floating text boxes near their respective cells.

Note: After using Show All Notes, you can hide individual notes selectively via the Show/Hide Note option. Additionally, any new notes added to the worksheet will automatically appear as visible sticky notes when Show All Notes is active.

This functionality enhances workflow efficiency by providing flexible control over note visibility, whether for individual focus or comprehensive review.

Show/Hide notes in Spreadsheet

Saving the document with notes

The Spreadsheet data, including notes, can be saved and exported as an Excel document by selecting File > Save As in the ribbon menu. Exporting worksheets with notes is supported in Excel file formats such as Microsoft Excel (.xlsx) and Microsoft Excel 97-2003 (.xls).

When exporting the Spreadsheet to file formats such as Comma Separated Values (.csv), Excel Macro-Enabled Workbook (.xlsm), Excel Binary Workbook (.xlsb), and PDF Document (.pdf), the notes will not be available.

Disabling notes

To disable the note functionality, you need to set the enableNotes property to false. After disabling, the notes in the document will not be shown when opened in the Spreadsheet. The Add Note option will not be shown in the context menu. The keyboard shortcuts for the note functionality will not work.

Spreadsheet with notes feature disabled

In the below example, the note functionality is disabled in the Spreadsheet.

import { Spreadsheet } from '@syncfusion/ej2-spreadsheet';

let sheet: SheetModel[] = [
    {
      ranges: [
        {
          dataSource: [
            {
              'Item Name': 'Casual Shoes',
              Date: '02/14/2014',
              Time: '11:34:32 AM',
              Quantity: 10,
              Price: 20,
              Amount: 200,
              Discount: 1,
              Profit: 10,
            },
            {
              'Item Name': 'Sports Shoes',
              Date: '06/11/2014',
              Time: '05:56:32 AM',
              Quantity: 20,
              Price: 30,
              Amount: 600,
              Discount: 5,
              Profit: 50,
            },
            {
              'Item Name': 'Formal Shoes',
              Date: '07/27/2014',
              Time: '03:32:44 AM',
              Quantity: 20,
              Price: 15,
              Amount: 300,
              Discount: 7,
              Profit: 27,
            },
            {
              'Item Name': 'Sandals & Floaters',
              Date: '11/21/2014',
              Time: '06:23:54 AM',
              Quantity: 15,
              Price: 20,
              Amount: 300,
              Discount: 11,
              Profit: 67,
            },
            {
              'Item Name': 'Flip- Flops & Slippers',
              Date: '06/23/2014',
              Time: '12:43:59 AM',
              Quantity: 30,
              Price: 10,
              Amount: 300,
              Discount: 10,
              Profit: 70,
            },
            {
              'Item Name': 'Sneakers',
              Date: '07/22/2014',
              Time: '10:55:53 AM',
              Quantity: 40,
              Price: 20,
              Amount: 800,
              Discount: 13,
              Profit: 66,
            },
            {
              'Item Name': 'Running Shoes',
              Date: '02/04/2014',
              Time: '03:44:34 AM',
              Quantity: 20,
              Price: 10,
              Amount: 200,
              Discount: 3,
              Profit: 14,
            },
            {
              'Item Name': 'Loafers',
              Date: '11/30/2014',
              Time: '03:12:52 AM',
              Quantity: 31,
              Price: 10,
              Amount: 310,
              Discount: 6,
              Profit: 29,
            },
            {
              'Item Name': 'Cricket Shoes',
              Date: '07/09/2014',
              Time: '11:32:14 AM',
              Quantity: 41,
              Price: 30,
              Amount: 1210,
              Discount: 12,
              Profit: 166,
            },
            {
              'Item Name': 'T-Shirts',
              Date: '10/31/2014',
              Time: '12:01:44 AM',
              Quantity: 50,
              Price: 10,
              Amount: 500,
              Discount: 9,
              Profit: 55,
            },
          ],
          startCell: 'A1',
        },
      ],
      rowCount: 200,
      columns: [
        {
          width: 130,
        },
        {
          width: 92,
        },
        {
          width: 96,
        },
      ],
    },
  ];


let spreadsheet: Spreadsheet = new Spreadsheet({
  sheets: sheet,
  enableNotes: false,
  allowOpen: true,
  openUrl: 'https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/open',
  allowSave: true,
  saveUrl: 'https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/save',
  created: function (): void {
    spreadsheet.cellFormat({ fontWeight: 'bold' }, 'A1:H1');
  }
});
spreadsheet.appendTo('#spreadsheet');
<!DOCTYPE html>
<html lang="en">

<head>
        <title>EJ2 SpreadSheet</title>
        <meta charset="utf-8" />
        <meta name="viewport" content="width=device-width, initial-scale=1.0" />
        <meta name="description" content="Typescript UI Controls" />
        <meta name="author" content="Syncfusion" />
        <link rel="shortcut icon" href="resources/favicon.ico" />
        <link href="https://cdn.syncfusion.com/ej2/33.1.44/tailwind3.css" rel="stylesheet" />
        <link href="https://cdn.syncfusion.com/ej2/33.1.44/ej2-base/styles/tailwind3.css" rel="stylesheet">
        <link href="https://cdn.syncfusion.com/ej2/33.1.44/ej2-grids/styles/tailwind3.css" rel="stylesheet">
        <link href="https://cdn.syncfusion.com/ej2/33.1.44/ej2-spreadsheet/styles/tailwind3.css" rel="stylesheet">
        <link href="styles.css" rel="stylesheet" />
        <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
        <script src="https://cdnjs.cloudflare.com/ajax/libs/core-js/2.4.1/shim.min.js"></script>
        <script src="system.config.js"></script>

<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
       <!--Element which is going to render-->
       <div id='loader'>Loading....</div>
       <div id='container'>
       <div id="spreadsheet"></div>
       </div>
</body>

</html>

Integrating notes during initial loading and using cell data binding

The notes can be added initially when the Spreadsheet loads using cell data binding. You need to use the notes property in the cell settings to add notes to the Spreadsheet.

In the below example, you can navigate between notes using Previous Note and Next Note options, toggle individual note visibility with Show/Hide Note, display all notes at once using Show All Notes and see how notes are added using the updateCell method in the created event.

import { Spreadsheet } from '@syncfusion/ej2-spreadsheet';

let sheet: SheetModel[] = [
  {
    name: 'PriceDetails',
    rows: [
      {
        cells: [
          { value: 'Item Name' },
          { value: 'Stock Detail' },
          { value: 'Website' },
        ],
      },
      {
        cells: [
          { value: 'Casual Shoes' },
          { value: 'OUT OF STOCK' },
          { value: 'Amazon' },
        ],
      },
      {
        cells: [
          {
            value: 'Sports Shoes',
            notes: {
              text: 'These shoes have the highest sales in terms of quantity this month.',
              isVisible: true
            },
          },
          { value: 'IN STOCK' },
          { value: 'Overstack' },
        ],
      },
      {
        cells: [
          { value: 'Formal Shoes' },
          { value: 'IN STOCK' },
          { value: 'AliExpress' },
        ],
      },
      {
        cells: [
          { value: 'Sandals & Floaters' },
          { value: 'OUT OF STOCK' },
          { value: 'AliBaba' },
        ],
      },
      {
        cells: [
          { value: 'Flip-Flops & Slippers' },
          { value: 'IN STOCK' },
          { value: 'Taobao' },
        ],
      },
    ],
    columns: [{ width: 160 }, { width: 160 }, { width: 120 }],
  },
  {
    name: 'Stock',
    rows: [
      {
        cells: [{ value: 'Item Name' }, { value: 'Available Count' }],
      },
      {
        cells: [{ value: 'Sports Shoes' }, { value: '30' }],
      },
      {
        cells: [{ value: 'Formal Shoes' }, { value: '25' }],
      },
      {
        cells: [{ value: 'Flip-Flops & Slippers' }, { value: '40' }],
      },
      {
        cells: [{ value: 'Running Shoes' }, { value: '25' }],
      },
    ],
    columns: [{ width: 160 }, { width: 120 }],
  },
];

let spreadsheet: Spreadsheet = new Spreadsheet({
  sheets: sheet,
  allowOpen: true,
  openUrl: 'https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/open',
  allowSave: true,
  saveUrl: 'https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/save',
  created: function (): void {
    spreadsheet.cellFormat({ fontWeight: 'bold' }, 'A1:C1');
    spreadsheet.updateCell({ notes: { text: 'This website is best for buying sports shoes.' } }, 'C3:C3');
  }
});
spreadsheet.appendTo('#spreadsheet');
<!DOCTYPE html>
<html lang="en">

<head>
        <title>EJ2 SpreadSheet</title>
        <meta charset="utf-8" />
        <meta name="viewport" content="width=device-width, initial-scale=1.0" />
        <meta name="description" content="Typescript UI Controls" />
        <meta name="author" content="Syncfusion" />
        <link rel="shortcut icon" href="resources/favicon.ico" />
        <link href="https://cdn.syncfusion.com/ej2/33.1.44/tailwind3.css" rel="stylesheet" />
        <link href="https://cdn.syncfusion.com/ej2/33.1.44/ej2-base/styles/tailwind3.css" rel="stylesheet">
        <link href="https://cdn.syncfusion.com/ej2/33.1.44/ej2-grids/styles/tailwind3.css" rel="stylesheet">
        <link href="https://cdn.syncfusion.com/ej2/33.1.44/ej2-spreadsheet/styles/tailwind3.css" rel="stylesheet">
        <link href="styles.css" rel="stylesheet" />
        <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
        <script src="https://cdnjs.cloudflare.com/ajax/libs/core-js/2.4.1/shim.min.js"></script>
        <script src="system.config.js"></script>

<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
       <!--Element which is going to render-->
       <div id='loader'>Loading....</div>
       <div id='container'>
       <div id="spreadsheet"></div>
       </div>
</body>

</html>

Limitations

  • When importing the document with notes, the formatting of the content in the notes will not be available. Similarly, while adding notes, we cannot apply formatting to them.
  • The style and appearance of the dialog box for the notes, including size, color, border, and other elements, cannot be directly changed.
  • Exporting the workbook along with notes is not supported in file formats such as Comma Separated Values (.csv), Excel Macro-Enabled Workbook (.xlsm), Excel Binary Workbook (.xlsb), and PDF Document (.pdf).
  • Notes added outside the used ranges of the worksheet will not be included in the exported document.

Notes in React Spreadsheet component

24 Jul 202624 minutes to read

The Notes feature is used to insert comments, provide feedback, suggest changes, or leave remarks on specific cells while reviewing documents in the Spreadsheet. You can enable or disable the notes functionality using the enableNotes property, which defaults to true.

  • When opening an Excel document with notes, they are displayed in the Spreadsheet control.
  • Cells containing notes are marked with a small red triangle in the top-right corner. Hovering over these cells shows the note content.

Adding, editing, and deleting a note in Spreadsheet

In the below example, you can add, edit, save, and delete notes.

import * as React from 'react';
import { createRoot } from 'react-dom/client';
import { SpreadsheetComponent, SheetsDirective, SheetDirective, RangesDirective } from '@syncfusion/ej2-react-spreadsheet';
import { RangeDirective, ColumnsDirective, ColumnDirective } from '@syncfusion/ej2-react-spreadsheet';
import { data } from './datasource';

function App() {
    const spreadsheetRef = React.useRef(null);
    function onCreated() {
        let spreadsheet = spreadsheetRef.current;
        if (spreadsheet) {
            spreadsheet.cellFormat({ fontWeight: 'bold', textAlign: 'center', verticalAlign: 'middle' }, 'A1:H1');
        }
    }

    return (
        <div>
            <SpreadsheetComponent ref={spreadsheetRef} allowOpen={true} allowSave={true} openUrl='https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/open' saveUrl='https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/save' created={onCreated.bind(this)}>
                <SheetsDirective>
                    <SheetDirective name="Price Details">
                        <RangesDirective>
                            <RangeDirective dataSource={data}></RangeDirective>
                        </RangesDirective>
                        <ColumnsDirective>
                            <ColumnDirective width={130}></ColumnDirective>
                            <ColumnDirective width={92}></ColumnDirective>
                            <ColumnDirective width={96}></ColumnDirective>
                        </ColumnsDirective>
                    </SheetDirective>
                </SheetsDirective>
            </SpreadsheetComponent>
        </div>
    );
};
export default App;

const root = createRoot(document.getElementById('root'));
root.render(<App />);
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import { SpreadsheetComponent, SheetsDirective, SheetDirective, RangesDirective } from '@syncfusion/ej2-react-spreadsheet';
import { RangeDirective, ColumnsDirective, ColumnDirective } from '@syncfusion/ej2-react-spreadsheet';
import { data } from './datasource';

function App() {
    const spreadsheetRef = React.useRef<SpreadsheetComponent>(null);
    function onCreated() {
        let spreadsheet = spreadsheetRef.current;
        if (spreadsheet) {
            spreadsheet.cellFormat({ fontWeight: 'bold', textAlign: 'center', verticalAlign: 'middle' }, 'A1:H1');
        }
    }

    return (
        <div>
            <SpreadsheetComponent ref={spreadsheetRef} allowOpen={true} allowSave={true} openUrl='https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/open' saveUrl='https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/save' created={onCreated.bind(this)}>
                <SheetsDirective>
                    <SheetDirective name="Price Details">
                        <RangesDirective>
                            <RangeDirective dataSource={data}></RangeDirective>
                        </RangesDirective>
                        <ColumnsDirective>
                            <ColumnDirective width={130}></ColumnDirective>
                            <ColumnDirective width={92}></ColumnDirective>
                            <ColumnDirective width={96}></ColumnDirective>
                        </ColumnsDirective>
                    </SheetDirective>
                </SheetsDirective>
            </SpreadsheetComponent>
        </div>
    );
};
export default App;

const root = createRoot(document.getElementById('root')!);
root.render(<App />);

Adding a note

In the active worksheet, you can add a note in the following ways:

  • Context Menu: Right-click the desired cell and select Add Note.
  • Ribbon: Select the cell, navigate to the Review tab, click the Notes dropdown, and select Add Note.
  • Keyboard Shortcut: Select the cell and press Shift + F2.
  • Programmatically:
    • Use the updateCell method with the note model to add a note to a specific cell.
    • Bind notes via code-behind during initial load by associating the note model with the cell model.

A dialog box will open where you can enter the note content. After entering the content, you can either click on other cells or press the Esc button to automatically save the note and close the dialog box.

Editing a note

In the active worksheet, you can modify the content of an existing notes in the document:

  • Context Menu: Right-click the cell containing the note and select Edit Note.
  • Ribbon: Select the cell containing the note, navigate to the Review tab, click the Notes dropdown, and select Edit Note.
  • Keyboard Shortcut: Select the cell containing the note and press Shift + F2.

The note editor dialog box will open with the existing content. After editing the content, you can either click on other cells or press the Esc button to automatically save the changes and close the dialog box.

Deleting a note

You can remove notes from cells using the following ways:

  • Context Menu: Right-click the cell containing the note and select Delete Note.
  • Ribbon: Select the cell containing the note, navigate to the Review tab, click the Notes dropdown, and select Delete Note.

The note will be removed from the cell, and the red triangle indicator will be removed.

The Spreadsheet provides intuitive navigation to quickly move between cells containing notes in your worksheet. These options are accessible through the Notes dropdown in the Review tab.

Navigating between notes in Spreadsheet

Previous Note

To navigate to the previous note:

  • Go to the Review tab, open the Notes dropdown, and select Previous Note.
  • The Spreadsheet will highlight the previous note in the current worksheet, searching leftward and then upward.
  • If no earlier note exists in the current sheet, the search continues in the previous worksheet.
  • If the workbook has no notes, the selection stays on the current cell.

Next Note

To navigate to the next note:

  • Go to the Review tab, open the Notes dropdown, and select Next Note.
  • The Spreadsheet will highlight the next note in the current worksheet, searching rightward and then downward.
  • If no later note exists in the current sheet, the search continues in the next worksheet.
  • If the workbook has no notes, the selection stays on the current cell.

This navigation feature streamlines reviewing by letting you jump directly between notes across worksheets.
It ensures efficient traversal, so you don’t miss any feedback or comments while working through your document.

Show/Hide Note

The Show/Hide Note option allows you to toggle the visibility of individual notes as sticky notes within the worksheet. When enabled, the note appears as a persistent floating text box, making it convenient to reference key information without hovering over the cell.

To toggle the visibility of a note:

  • Context Menu: Right-click the cell containing the note and select Show/Hide Note.
  • Ribbon: Select the cell, go to the Review tab, click the Notes dropdown, and choose Show/Hide Note.

Behavior:

  • Default State (Hidden): Notes are hidden by default and only appear when hovering over the cell, which displays a red triangle indicator.
  • Sticky State (Visible): Toggling Show/Hide Note on a hidden note makes it visible as a sticky note, which remains on display even when navigating to other cells or selections.
  • Toggle Functionality: Selecting Show/Hide Note again on a visible note hides it, reverting to the default state.
  • Independent Control: Each note can be toggled individually, allowing you to display only the most relevant notes for your current task.

Show All Notes

The Show All Notes option enables you to display all notes in the current worksheet simultaneously as sticky notes, simplifying the review of multiple comments at a glance.

To activate:

  • Navigate to the Review tab, click the Notes dropdown, and select Show All Notes.

All notes in the worksheet will appear as floating text boxes near their respective cells.

Note: After using Show All Notes, you can hide individual notes selectively via the Show/Hide Note option. Additionally, any new notes added to the worksheet will automatically appear as visible sticky notes when Show All Notes is active.

This functionality enhances workflow efficiency by providing flexible control over note visibility, whether for individual focus or comprehensive review.

Show/Hide notes in Spreadsheet

Saving the Document with Notes

You can save and export Spreadsheet data along with notes into an Excel document.
To do this, go to File > Save As in the ribbon menu.

Notes are preserved when exporting to:

  • Microsoft Excel (.xlsx)
  • Microsoft Excel 97–2003 (.xls)

Notes are not included when exporting to:

  • Comma Separated Values (.csv)
  • Excel Macro-Enabled Workbook (.xlsm)
  • Excel Binary Workbook (.xlsb)
  • PDF Document (.pdf)

Disabling notes

To disable the note functionality, you need to set the enableNotes property to false.

  • Notes in the document will not be displayed when opened in the Spreadsheet when enableNotes set to false.
  • The Add Note option will be removed from the context menu.
  • Keyboard shortcuts related to notes will no longer work.

Spreadsheet with notes feature disabled

In the below example, the note functionality is disabled in the Spreadsheet.

import * as React from 'react';
import { createRoot } from 'react-dom/client';
import { SpreadsheetComponent, SheetsDirective, SheetDirective, RangesDirective } from '@syncfusion/ej2-react-spreadsheet';
import { RangeDirective, ColumnsDirective, ColumnDirective } from '@syncfusion/ej2-react-spreadsheet';
import { data } from './datasource';

function App() {
    const spreadsheetRef = React.useRef(null);
    function onCreated() {
        let spreadsheet = spreadsheetRef.current;
        if (spreadsheet) {
            spreadsheet.cellFormat({ fontWeight: 'bold', textAlign: 'center', verticalAlign: 'middle' }, 'A1:H1');
        }
    }

    return (
        <div>
            <SpreadsheetComponent ref={spreadsheetRef} allowOpen={true} allowSave={true} openUrl='https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/open' saveUrl='https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/save' created={onCreated.bind(this)} enableNotes={false}>
                <SheetsDirective>
                    <SheetDirective name="Price Details">
                        <RangesDirective>
                            <RangeDirective dataSource={data}></RangeDirective>
                        </RangesDirective>
                        <ColumnsDirective>
                            <ColumnDirective width={130}></ColumnDirective>
                            <ColumnDirective width={92}></ColumnDirective>
                            <ColumnDirective width={96}></ColumnDirective>
                        </ColumnsDirective>
                    </SheetDirective>
                </SheetsDirective>
            </SpreadsheetComponent>
        </div>
    );
};
export default App;

const root = createRoot(document.getElementById('root'));
root.render(<App />);
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import { SpreadsheetComponent, SheetsDirective, SheetDirective, RangesDirective } from '@syncfusion/ej2-react-spreadsheet';
import { RangeDirective, ColumnsDirective, ColumnDirective } from '@syncfusion/ej2-react-spreadsheet';
import { data } from './datasource';

function App() {
    const spreadsheetRef = React.useRef<SpreadsheetComponent>(null);
    function onCreated() {
        let spreadsheet = spreadsheetRef.current;
        if (spreadsheet) {
            spreadsheet.cellFormat({ fontWeight: 'bold', textAlign: 'center', verticalAlign: 'middle' }, 'A1:H1');
        }
    }

    return (
        <div>
            <SpreadsheetComponent ref={spreadsheetRef} allowOpen={true} allowSave={true} openUrl='https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/open' saveUrl='https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/save' created={onCreated.bind(this)} enableNotes={false}>
                <SheetsDirective>
                    <SheetDirective name="Price Details">
                        <RangesDirective>
                            <RangeDirective dataSource={data}></RangeDirective>
                        </RangesDirective>
                        <ColumnsDirective>
                            <ColumnDirective width={130}></ColumnDirective>
                            <ColumnDirective width={92}></ColumnDirective>
                            <ColumnDirective width={96}></ColumnDirective>
                        </ColumnsDirective>
                    </SheetDirective>
                </SheetsDirective>
            </SpreadsheetComponent>
        </div>
    );
};
export default App;

const root = createRoot(document.getElementById('root')!);
root.render(<App />);

Integrating Notes During Initial Loading and Using Cell Data Binding

You can add notes to cells initially when the Spreadsheet loads by using cell data binding.
This is done through the notes property in the cell settings.

  • Define the notes property inside the cell configuration.
  • When the Spreadsheet initializes, the notes will automatically appear in the specified cells.
  • Each cell can have its own note content bound through the model.

In the below example, you can navigate between notes using Previous Note and Next Note options, toggle individual note visibility with Show/Hide Note, display all notes at once using Show All Notes and see how notes are added using the updateCell method in the created event.

import * as React from 'react';
import { createRoot } from 'react-dom/client';
import { SpreadsheetComponent, SheetsDirective, SheetDirective, RangesDirective, RowsDirective, RowDirective } from '@syncfusion/ej2-react-spreadsheet';
import { RangeDirective, ColumnsDirective, ColumnDirective, CellsDirective, CellDirective  } from '@syncfusion/ej2-react-spreadsheet';
import { data } from './datasource';

function App() {
    const spreadsheetRef = React.useRef(null);
    function onCreated() {
        let spreadsheet = spreadsheetRef.current;
        if (spreadsheet) {
            spreadsheet.cellFormat({ fontWeight: 'bold', textAlign: 'center', verticalAlign: 'middle' }, 'A1:H1');
            spreadsheet.updateCell({ notes: { text: 'These shoes have been the most profitable this month.' } }, 'A10:A10');
        }
    }

    return (
        <div>
            <SpreadsheetComponent ref={spreadsheetRef} allowOpen={true} allowSave={true} openUrl='https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/open' saveUrl='https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/save' created={onCreated.bind(this)}>
                <SheetsDirective>
                    <SheetDirective name="Price Details">
                        <RangesDirective>
                            <RangeDirective dataSource={data}></RangeDirective>
                        </RangesDirective>
                        <RowsDirective>
                            <RowDirective index={2}>
                                <CellsDirective>
                                    <CellDirective index={0} notes=></CellDirective>
                                </CellsDirective>
                            </RowDirective>
                        </RowsDirective>
                        <ColumnsDirective>
                            <ColumnDirective width={130}></ColumnDirective>
                            <ColumnDirective width={92}></ColumnDirective>
                            <ColumnDirective width={96}></ColumnDirective>
                        </ColumnsDirective>
                    </SheetDirective>
                </SheetsDirective>
            </SpreadsheetComponent>
        </div>
    );
};
export default App;

const root = createRoot(document.getElementById('root'));
root.render(<App />);
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import { SpreadsheetComponent, SheetsDirective, SheetDirective, RangesDirective, RowsDirective, RowDirective, CellsDirective, CellDirective, } from '@syncfusion/ej2-react-spreadsheet';
import { RangeDirective, ColumnsDirective, ColumnDirective } from '@syncfusion/ej2-react-spreadsheet';
import { data } from './datasource';

function App() {
    const spreadsheetRef = React.useRef<SpreadsheetComponent>(null);
    function onCreated() {
        let spreadsheet = spreadsheetRef.current;
        if (spreadsheet) {
            spreadsheet.cellFormat({ fontWeight: 'bold', textAlign: 'center', verticalAlign: 'middle' }, 'A1:H1');
            spreadsheet.updateCell({ notes: { text: 'These shoes have been the most profitable this month.' } }, 'A10:A10');
        }
    }

    return (
        <div>
            <SpreadsheetComponent ref={spreadsheetRef} allowOpen={true} allowSave={true} openUrl='https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/open' saveUrl='https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/save' created={onCreated.bind(this)}>
                <SheetsDirective>
                    <SheetDirective name="Price Details">
                        <RangesDirective>
                            <RangeDirective dataSource={data}></RangeDirective>
                        </RangesDirective>
                        <RowsDirective>
                            <RowDirective index={2}>
                                <CellsDirective>
                                    <CellDirective index={0} notes=></CellDirective>
                                </CellsDirective>
                            </RowDirective>
                        </RowsDirective>
                        <ColumnsDirective>
                            <ColumnDirective width={130}></ColumnDirective>
                            <ColumnDirective width={92}></ColumnDirective>
                            <ColumnDirective width={96}></ColumnDirective>
                        </ColumnsDirective>
                    </SheetDirective>
                </SheetsDirective>
            </SpreadsheetComponent>
        </div>
    );
};
export default App;

const root = createRoot(document.getElementById('root')!);
root.render(<App />);

Limitations

  • When importing a document with notes, the formatting of the content in the notes will not be available. Similarly, while adding notes, we cannot apply formatting to them.
  • The style and appearance of the dialog box for the notes, including size, color, border, and other elements, cannot be directly changed.
  • Exporting the workbook along with notes is not supported in file formats such as Comma Separated Values (.csv), Excel Macro-Enabled Workbook (.xlsm), Excel Binary Workbook (.xlsb), and PDF Document (.pdf).
  • Notes added outside the used ranges of the worksheet will not be included in the exported document.

Notes in Vue Spreadsheet component

27 Jul 202624 minutes to read

The Notes feature is used to insert comments, provide feedback, suggest changes, or leave remarks on specific cells while reviewing documents in the Spreadsheet. You can enable or disable the notes functionality using the enableNotes property, which defaults to true.

When opening the Excel document with notes in the Spreadsheet, they will be displayed in the control. The cells containing notes will be indicated with a red colored triangle at the top-right corner. Hovering the mouse over these cells will display the content of the notes.

Adding, editing, and deleting a note in Spreadsheet

In the below example, you can add, edit, save, and delete notes.

<template>
  <ejs-spreadsheet ref="spreadsheet" :created="created" :allowOpen="true" :openUrl="openUrl" :allowSave="true" :saveUrl="saveUrl">
    <e-sheets>
      <e-sheet name="Price Details">
        <e-ranges>
          <e-range :dataSource="dataSource"></e-range>
        </e-ranges>
        <e-columns>
          <e-column :width="width1"></e-column>
          <e-column :width="width2"></e-column>
          <e-column :width="width2"></e-column>
          <e-column :width="width3"></e-column>
        </e-columns>
      </e-sheet>
    </e-sheets>
  </ejs-spreadsheet>
</template>

<script setup>
import { ref } from "vue";
import { SpreadsheetComponent as EjsSpreadsheet, ColumnsDirective as EColumns, ColumnDirective as EColumn, RowsDirective as ERows, RowDirective as ERow, CellsDirective as ECells, CellDirective as ECell, RangesDirective as ERanges, RangeDirective as ERange, SheetsDirective as ESheets, SheetDirective as ESheet } from "@syncfusion/ej2-vue-spreadsheet";
import { data } from './data.js';

const spreadsheet = ref(null);
const dataSource = data;
const openUrl = 'https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/open';
const saveUrl = 'https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/save';
const width1 = 180;
const width2 = 130;
const width3 = 120;

const created = function () {
  spreadsheet.value.cellFormat({ fontWeight: 'bold', textAlign: 'center' }, 'A1:H1');
  spreadsheet.value.cellFormat({ verticalAlign: 'middle' }, 'A1:H11');
}
</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-grids/styles/tailwind3.css';
@import "../node_modules/@syncfusion/ej2-vue-spreadsheet/styles/tailwind3.css";
</style>
<template>
  <ejs-spreadsheet ref="spreadsheet" :created="created" :allowOpen="true" :openUrl="openUrl" :allowSave="true" :saveUrl="saveUrl">
    <e-sheets>
      <e-sheet name="Price Details">
        <e-ranges>
          <e-range :dataSource="dataSource"></e-range>
        </e-ranges>
        <e-columns>
          <e-column :width="width1"></e-column>
          <e-column :width="width2"></e-column>
          <e-column :width="width2"></e-column>
          <e-column :width="width3"></e-column>
        </e-columns>
      </e-sheet>
    </e-sheets>
  </ejs-spreadsheet>
</template>

<script>
import { SpreadsheetComponent, ColumnsDirective, ColumnDirective, RowsDirective, RowDirective, CellsDirective, CellDirective, RangesDirective, RangeDirective, SheetsDirective, SheetDirective } from "@syncfusion/ej2-vue-spreadsheet";
import { data } from './data.js';

export default {
  name: "App",
  components: {
    "ejs-spreadsheet": SpreadsheetComponent,
    "e-sheets": SheetsDirective,
    "e-sheet": SheetDirective,
    "e-ranges": RangesDirective,
    "e-range": RangeDirective,
    "e-columns": ColumnsDirective,
    "e-column": ColumnDirective,
    "e-rows": RowsDirective,
    "e-row": RowDirective,
    "e-cells": CellsDirective,
    "e-cell": CellDirective
  },
  data: () => {
    return {
      dataSource: data,
      openUrl: 'https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/open',
      saveUrl: 'https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/save',
      width1: 180,
      width2: 130,
      width3: 120
    }
  },
  methods: {
    created: function () {
      let spreadsheet = this.$refs.spreadsheet;
      spreadsheet.cellFormat({ fontWeight: 'bold', textAlign: 'center' }, 'A1:H1');
      spreadsheet.cellFormat({ verticalAlign: 'middle' }, 'A1:H11');
    }
  }
}
</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-grids/styles/tailwind3.css';
@import "../node_modules/@syncfusion/ej2-vue-spreadsheet/styles/tailwind3.css";
</style>

Adding a note

In the active worksheet, you can add a note in the following ways:

  • Context Menu: Right-click the desired cell and select Add Note.
  • Ribbon: Select the cell, navigate to the Review tab, click the Notes dropdown, and select Add Note.
  • Keyboard Shortcut: Select the cell and press Shift + F2.
  • Programmatically:
    • Use the updateCell method with the note model to add a note to a specific cell.
    • Bind notes via code-behind during initial load by associating the note model with the cell model.

A dialog box will open where you can enter the note content. After entering the content, you can either click on other cells or press the Esc button to automatically save the note and close the dialog box.

Editing a note

In the active worksheet, you can modify the content of existing notes in the document:

  • Context Menu: Right-click the cell containing the note and select Edit Note.
  • Ribbon: Select the cell containing the note, navigate to the Review tab, click the Notes dropdown, and select Edit Note.
  • Keyboard Shortcut: Select the cell containing the note and press Shift + F2.

The note editor dialog box will open with the existing content. After editing the content, you can either click on other cells or press the Esc button to automatically save the changes and close the dialog box.

Deleting a note

You can remove notes from cells using the following ways:

  • Context Menu: Right-click the cell containing the note and select Delete Note.
  • Ribbon: Select the cell containing the note, navigate to the Review tab, click the Notes dropdown, and select Delete Note.

The note will be removed from the cell, and the red triangle indicator will be removed.

The Syncfusion Spreadsheet provides navigation to move quickly between cells containing notes in your worksheet. These options are accessible through the Notes dropdown in the Review tab.

Navigating between notes in Spreadsheet

Previous Note

To navigate to the previous note:

  • In the Review tab, open the Notes dropdown and select Previous Note.
  • The Spreadsheet automatically selects the previous note in the current worksheet, searching leftward and then upward.
  • If no prior note exists in the sheet, the search continues to the previous worksheet in order.
  • If the workbook contains no notes, the selection remains on the current cell.

Next Note

To navigate to the next note:

  • In the Review tab, open the Notes dropdown and select Next Note.
  • The Spreadsheet automatically selects the next note in the current worksheet, searching rightward and then downward.
  • If no subsequent note exists in the sheet, the search continues to the next worksheet in order.
  • If the workbook contains no notes, the selection remains on the current cell.

This functionality streamlines the process of reviewing notes across worksheets, ensuring efficient traversal and discovery.

Show/Hide Note

The Show/Hide Note option allows you to toggle the visibility of individual notes as sticky notes within the worksheet. When enabled, the note appears as a persistent floating text box, making it convenient to reference key information without hovering over the cell.

To toggle the visibility of a note:

  • Context Menu: Right-click the cell containing the note and select Show/Hide Note.
  • Ribbon: Select the cell, go to the Review tab, click the Notes dropdown, and choose Show/Hide Note.

Behavior:

  • Default State (Hidden): Notes are hidden by default and only appear when hovering over the cell, which displays a red triangle indicator.
  • Sticky State (Visible): Toggling Show/Hide Note on a hidden note makes it visible as a sticky note, which remains on display even when navigating to other cells or selections.
  • Toggle Functionality: Selecting Show/Hide Note again on a visible note hides it, reverting to the default state.
  • Independent Control: Each note can be toggled individually, allowing you to display only the most relevant notes for your current task.

Show All Notes

The Show All Notes option enables you to display all notes in the current worksheet simultaneously as sticky notes, simplifying the review of multiple comments at a glance.

To activate:

  • Navigate to the Review tab, click the Notes dropdown, and select Show All Notes.

All notes in the worksheet appear as floating text boxes near their respective cells.

Note: After using Show All Notes, you can hide individual notes selectively via the Show/Hide Note option. Additionally, any new notes added to the worksheet will automatically appear as visible sticky notes when Show All Notes is active.

This functionality enhances workflow efficiency by providing flexible control over note visibility, whether for individual focus or comprehensive review.

Show/Hide notes in Spreadsheet

Saving the document with notes

The Spreadsheet data, including notes, can be saved and exported as an Excel document by selecting File > Save As in the ribbon menu. Exporting worksheets with notes is supported in Excel file formats such as Microsoft Excel (.xlsx) and Microsoft Excel 97-2003 (.xls).

When exporting the Spreadsheet to file formats such as Comma Separated Values (.csv), Excel Macro-Enabled Workbook (.xlsm), Excel Binary Workbook (.xlsb), and PDF Document (.pdf), the notes will not be available.

Disabling notes

To disable the note functionality, you need to set the enableNotes property to false. After disabling, the notes in the document will not be shown when opened in the Spreadsheet. The “Add Note” option will not be shown in the context menu. The keyboard shortcuts for the note functionality will not work.

Spreadsheet with notes feature disabled

In the below example, the note functionality is disabled in the Spreadsheet.

<template>
  <ejs-spreadsheet ref="spreadsheet" :created="created" :allowOpen="true" :openUrl="openUrl" :allowSave="true" :saveUrl="saveUrl" :enableNotes="false">
    <e-sheets>
      <e-sheet name="Price Details">
        <e-ranges>
          <e-range :dataSource="dataSource"></e-range>
        </e-ranges>
        <e-columns>
          <e-column :width="width1"></e-column>
          <e-column :width="width2"></e-column>
          <e-column :width="width2"></e-column>
          <e-column :width="width3"></e-column>
        </e-columns>
      </e-sheet>
    </e-sheets>
  </ejs-spreadsheet>
</template>

<script setup>
import { ref } from "vue";
import { SpreadsheetComponent as EjsSpreadsheet, ColumnsDirective as EColumns, ColumnDirective as EColumn, RowsDirective as ERows, RowDirective as ERow, CellsDirective as ECells, CellDirective as ECell, RangesDirective as ERanges, RangeDirective as ERange, SheetsDirective as ESheets, SheetDirective as ESheet } from "@syncfusion/ej2-vue-spreadsheet";
import { data } from './data.js';

const spreadsheet = ref(null);
const dataSource = data;
const openUrl = 'https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/open';
const saveUrl = 'https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/save';
const width1 = 180;
const width2 = 130;
const width3 = 120;

const created = function () {
  spreadsheet.value.cellFormat({ fontWeight: 'bold', textAlign: 'center' }, 'A1:H1');
  spreadsheet.value.cellFormat({ verticalAlign: 'middle' }, 'A1:H11');
}
</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-grids/styles/tailwind3.css';
@import "../node_modules/@syncfusion/ej2-vue-spreadsheet/styles/tailwind3.css";
</style>
<template>
  <ejs-spreadsheet ref="spreadsheet" :created="created" :allowOpen="true" :openUrl="openUrl" :allowSave="true" :saveUrl="saveUrl" :enableNotes="false">
    <e-sheets>
      <e-sheet name="Price Details">
        <e-ranges>
          <e-range :dataSource="dataSource"></e-range>
        </e-ranges>
        <e-columns>
          <e-column :width="width1"></e-column>
          <e-column :width="width2"></e-column>
          <e-column :width="width2"></e-column>
          <e-column :width="width3"></e-column>
        </e-columns>
      </e-sheet>
    </e-sheets>
  </ejs-spreadsheet>
</template>

<script>
import { SpreadsheetComponent, ColumnsDirective, ColumnDirective, RowsDirective, RowDirective, CellsDirective, CellDirective, RangesDirective, RangeDirective, SheetsDirective, SheetDirective } from "@syncfusion/ej2-vue-spreadsheet";
import { data } from './data.js';

export default {
  name: "App",
  components: {
    "ejs-spreadsheet": SpreadsheetComponent,
    "e-sheets": SheetsDirective,
    "e-sheet": SheetDirective,
    "e-ranges": RangesDirective,
    "e-range": RangeDirective,
    "e-columns": ColumnsDirective,
    "e-column": ColumnDirective,
    "e-rows": RowsDirective,
    "e-row": RowDirective,
    "e-cells": CellsDirective,
    "e-cell": CellDirective
  },
  data: () => {
    return {
      dataSource: data,
      openUrl: 'https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/open',
      saveUrl: 'https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/save',
      width1: 180,
      width2: 130,
      width3: 120
    }
  },
  methods: {
    created: function () {
      let spreadsheet = this.$refs.spreadsheet;
      spreadsheet.cellFormat({ fontWeight: 'bold', textAlign: 'center' }, 'A1:H1');
      spreadsheet.cellFormat({ verticalAlign: 'middle' }, 'A1:H11');
    }
  }
}
</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-grids/styles/tailwind3.css';
@import "../node_modules/@syncfusion/ej2-vue-spreadsheet/styles/tailwind3.css";
</style>

Integrating notes during initial loading and using cell data binding

The notes can be added initially when the Spreadsheet loads using cell data binding. You need to use the notes property in the cell settings to add notes to the Spreadsheet.

In the below example, you can navigate between notes using Previous Note and Next Note options, toggle individual note visibility with Show/Hide Note, display all notes at once using Show All Notes and see how notes are added using the updateCell method in the created event.

<template>
  <ejs-spreadsheet ref="spreadsheet" :created="created" :allowOpen="true" :openUrl="openUrl" :allowSave="true" :saveUrl="saveUrl">
    <e-sheets>
      <e-sheet name="Price Details">
        <e-ranges>
          <e-range :dataSource="dataSource"></e-range>
        </e-ranges>
        <e-rows>
          <e-row :index="rowIndex" :cells="cells" ></e-row>
          <e-row :index="rowIndex1" :cells="cells1" ></e-row>
        </e-rows>
        <e-columns>
          <e-column :width="width1"></e-column>
          <e-column :width="width2"></e-column>
          <e-column :width="width2"></e-column>
          <e-column :width="width3"></e-column>
        </e-columns>
      </e-sheet>
    </e-sheets>
  </ejs-spreadsheet>
</template>

<script setup>
import { ref } from "vue";
import { SpreadsheetComponent as EjsSpreadsheet, ColumnsDirective as EColumns, ColumnDirective as EColumn, RowsDirective as ERows, RowDirective as ERow, CellsDirective as ECells, CellDirective as ECell, RangesDirective as ERanges, RangeDirective as ERange, SheetsDirective as ESheets, SheetDirective as ESheet } from "@syncfusion/ej2-vue-spreadsheet";
import { data } from './data.js';

const spreadsheet = ref(null);
const dataSource = data;
const openUrl = 'https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/open';
const saveUrl = 'https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/save';
const width1 = 180;
const width2 = 130;
const width3 = 120;
const rowIndex= 2;
const cells: [{index: 0, notes: { text: 'These shoes have the highest sales in terms of quantity this month.', isVisible: true } }];
const created = function () {
  spreadsheet.value.cellFormat({ fontWeight: 'bold', textAlign: 'center' }, 'A1:H1');
  spreadsheet.value.cellFormat({ verticalAlign: 'middle' }, 'A1:H11');
  spreadsheet.updateCell({ notes: { text: 'These shoes have been the most profitable this month.' } }, 'A10:A10');
}
</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-grids/styles/tailwind3.css';
@import "../node_modules/@syncfusion/ej2-vue-spreadsheet/styles/tailwind3.css";
</style>
<template>
  <ejs-spreadsheet ref="spreadsheet" :created="created" :allowOpen="true" :openUrl="openUrl" :allowSave="true" :saveUrl="saveUrl">
    <e-sheets>
      <e-sheet name="Price Details">
        <e-ranges>
          <e-range :dataSource="dataSource"></e-range>
        </e-ranges>
        <e-rows>
          <e-row :index="rowIndex" :cells="cells" ></e-row>
          <e-row :index="rowIndex1" :cells="cells1" ></e-row>
        </e-rows>
        <e-columns>
          <e-column :width="width1"></e-column>
          <e-column :width="width2"></e-column>
          <e-column :width="width2"></e-column>
          <e-column :width="width3"></e-column>
        </e-columns>
      </e-sheet>
    </e-sheets>
  </ejs-spreadsheet>
</template>

<script>
import { SpreadsheetComponent, ColumnsDirective, ColumnDirective, RowsDirective, RowDirective, CellsDirective, CellDirective, RangesDirective, RangeDirective, SheetsDirective, SheetDirective } from "@syncfusion/ej2-vue-spreadsheet";
import { data } from './data.js';

export default {
  name: "App",
  components: {
    "ejs-spreadsheet": SpreadsheetComponent,
    "e-sheets": SheetsDirective,
    "e-sheet": SheetDirective,
    "e-ranges": RangesDirective,
    "e-range": RangeDirective,
    "e-columns": ColumnsDirective,
    "e-column": ColumnDirective,
    "e-rows": RowsDirective,
    "e-row": RowDirective,
    "e-cells": CellsDirective,
    "e-cell": CellDirective
  },
  data: () => {
    return {
      dataSource: data,
      openUrl: 'https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/open',
      saveUrl: 'https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/save',
      width1: 180,
      width2: 130,
      width3: 120,
      rowIndex: 2,
      cells: [{index: 0, notes: { text: 'These shoes have the highest sales in terms of quantity this month.', isVisible: true } }]
    }
  },
  methods: {
    created: function () {
      let spreadsheet = this.$refs.spreadsheet;
      spreadsheet.cellFormat({ fontWeight: 'bold', textAlign: 'center' }, 'A1:H1');
      spreadsheet.cellFormat({ verticalAlign: 'middle' }, 'A1:H11');
      spreadsheet.updateCell({ notes: { text: 'These shoes have been the most profitable this month.' } }, 'A10:A10');
    }
  }
}
</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css';
@import '../node_modules/@syncfusion/ej2-grids/styles/tailwind3.css';
@import "../node_modules/@syncfusion/ej2-vue-spreadsheet/styles/tailwind3.css";
</style>

Limitations

  • When importing the document with notes, the formatting of the content in the notes will not be available. Similarly, while adding notes, we cannot apply formatting to them.
  • The style and appearance of the dialog box for the notes, including size, color, border, and other elements, cannot be directly changed.
  • Exporting the workbook along with notes is not supported in file formats such as Comma Separated Values (.csv), Excel Macro-Enabled Workbook (.xlsm), Excel Binary Workbook (.xlsb), and PDF Document (.pdf).
  • Notes added outside the used ranges of the worksheet will not be included in the exported document.

Notes in Angular Spreadsheet component

6 Feb 202613 minutes to read

The Notes feature is used to insert comments, provide feedback, suggest changes, or leave remarks on specific cells while reviewing documents in the Spreadsheet. You can enable or disable the notes functionality using the enableNotes property, which defaults to true.

When opening the Excel document with notes in the Spreadsheet, they will be displayed in the control. The cells containing notes will be indicated with a red colored triangle at the top-right corner. Hovering the mouse over these cells will display the content of the notes.

Adding, editing, and deleting a note in Spreadsheet

In the below example, you can add, edit, save, and delete notes.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { SpreadsheetAllModule } from '@syncfusion/ej2-angular-spreadsheet'

import { Component, ViewChild } from '@angular/core';
import { SpreadsheetComponent } from '@syncfusion/ej2-angular-spreadsheet';
import { dataSource } from './datasource';


@Component({
  imports: [

    SpreadsheetAllModule
  ],


  standalone: true,
  selector: 'app-container',
  template: `<ejs-spreadsheet #spreadsheet (created)="created()" [openUrl]="openUrl" allowOpen="true" [saveUrl]="saveUrl" allowSave="true" >
  <e-sheets>
      <e-sheet name="Price Details">
          <e-ranges>
              <e-range [dataSource]="data"></e-range>
          </e-ranges>
          <e-columns>
              <e-column [width]=140></e-column>
              <e-column [width]=110></e-column>
              <e-column [width]=110></e-column>
              <e-column [width]=80></e-column>
          </e-columns>
      </e-sheet>
  </e-sheets>
</ejs-spreadsheet>`,
})
export class AppComponent {
  @ViewChild('spreadsheet')
  public spreadsheetObj: SpreadsheetComponent | undefined;
  public data: object[] = dataSource;
  public openUrl = 'https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/open';
  public saveUrl = 'https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/save';
  created() {
    this.spreadsheetObj!.cellFormat({ fontWeight: 'bold', textAlign: 'center', verticalAlign: 'middle' }, 'A1:H1');
  };
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Adding a note

In the active worksheet, you can add a note in the following ways:

  • Context Menu: Right-click the desired cell and select Add Note.
  • Ribbon: Select the cell, navigate to the Review tab, click the Notes dropdown, and select Add Note.
  • Keyboard Shortcut: Select the cell and press Shift + F2.
  • Programmatically:
    • Use the updateCell method with the note model to add a note to a specific cell.
    • Bind notes via code-behind during initial load by associating the note model with the cell model.

A dialog box will open where you can enter the note content. After entering the content, you can either click on other cells or press the Esc button to automatically save the note and close the dialog box.

Editing a note

In the active worksheet, you can modify the content of existing notes in the document:

  • Context Menu: Right-click the cell containing the note and select Edit Note.
  • Ribbon: Select the cell containing the note, navigate to the Review tab, click the Notes dropdown, and select Edit Note.
  • Keyboard Shortcut: Select the cell containing the note and press Shift + F2.

The note editor dialog box will open with the existing content. After editing the content, you can either click on other cells or press the Esc button to automatically save the changes and close the dialog box.

Deleting a note

You can remove notes from cells using the following ways:

  • Context Menu: Right-click the cell containing the note and select Delete Note.
  • Ribbon: Select the cell containing the note, navigate to the Review tab, click the Notes dropdown, and select Delete Note.

The note will be removed from the cell, and the red triangle indicator will be removed.

The Syncfusion Spreadsheet provides intuitive navigation to quickly move between cells containing notes in your worksheet. These options are accessible through the Notes dropdown in the Review tab.

Navigating between notes in Spreadsheet

Previous Note

To navigate to the previous note:

  • In the Review tab, open the Notes dropdown and select Previous Note.
  • The Spreadsheet will automatically select the previous note in the current worksheet, searching leftward and then upward.
  • If no prior note exists in the sheet, the search continues to the previous worksheet in order.
  • If the workbook contains no notes, the selection remains on the current cell.

Next Note

To navigate to the next note:

  • In the Review tab, open the Notes dropdown and select Next Note.
  • The Spreadsheet will automatically select the next note in the current worksheet, searching rightward and then downward.
  • If no subsequent note exists in the sheet, the search continues to the next worksheet in order.
  • If the workbook contains no notes, the selection remains on the current cell.

This functionality streamlines the process of reviewing notes across worksheets, ensuring efficient traversal and discovery.

Show/Hide Note

The Show/Hide Note option allows you to toggle the visibility of individual notes as sticky notes within the worksheet. When enabled, the note appears as a persistent floating text box, making it convenient to reference key information without hovering over the cell.

To toggle the visibility of a note:

  • Context Menu: Right-click the cell containing the note and select Show/Hide Note.
  • Ribbon: Select the cell, go to the Review tab, click the Notes dropdown, and choose Show/Hide Note.

Behavior:

  • Default State (Hidden): Notes are hidden by default and only appear when hovering over the cell, which displays a red triangle indicator.
  • Sticky State (Visible): Toggling Show/Hide Note on a hidden note makes it visible as a sticky note, which remains on display even when navigating to other cells or selections.
  • Toggle Functionality: Selecting Show/Hide Note again on a visible note hides it, reverting to the default state.
  • Independent Control: Each note can be toggled individually, allowing you to display only the most relevant notes for your current task.

Show All Notes

The Show All Notes option enables you to display all notes in the current worksheet simultaneously as sticky notes, simplifying the review of multiple comments at a glance.

To activate:

  • Navigate to the Review tab, click the Notes dropdown, and select Show All Notes.

All notes in the worksheet will appear as floating text boxes near their respective cells.

Note: After using Show All Notes, you can hide individual notes selectively via the Show/Hide Note option. Additionally, any new notes added to the worksheet will automatically appear as visible sticky notes when Show All Notes is active.

This functionality enhances workflow efficiency by providing flexible control over note visibility, whether for individual focus or comprehensive review.

Show/Hide notes in Spreadsheet

Saving the document with notes

The Spreadsheet data, including notes, can be saved and exported as an Excel document by selecting File > Save As in the ribbon menu. Exporting worksheets with notes is supported in Excel file formats such as Microsoft Excel (.xlsx) and Microsoft Excel 97-2003 (.xls).

When exporting the Spreadsheet to file formats such as Comma Separated Values (.csv), Excel Macro-Enabled Workbook (.xlsm), Excel Binary Workbook (.xlsb), and PDF Document (.pdf), the notes will not be available.

Disabling notes

To disable the note functionality, you need to set the enableNotes property to false. After disabling, the notes in the document will not be shown when opened in the Spreadsheet. The “Add Note” option will not be shown in the context menu. The keyboard shortcuts for the note functionality will not work.

Spreadsheet with notes feature disabled

In the below example, the note functionality is disabled in the Spreadsheet.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { SpreadsheetAllModule } from '@syncfusion/ej2-angular-spreadsheet'

import { Component, ViewChild } from '@angular/core';
import { SpreadsheetComponent } from '@syncfusion/ej2-angular-spreadsheet';
import { dataSource } from './datasource';


@Component({
  imports: [

    SpreadsheetAllModule
  ],


  standalone: true,
  selector: 'app-container',
  template: `<ejs-spreadsheet #spreadsheet (created)="created()" [openUrl]="openUrl" allowOpen="true" [saveUrl]="saveUrl" allowSave="true" [enableNotes]="false">
  <e-sheets>
      <e-sheet name="Price Details">
          <e-ranges>
              <e-range [dataSource]="data"></e-range>
          </e-ranges>
          <e-columns>
          <e-column [width]=140></e-column>
              <e-column [width]=110></e-column>
              <e-column [width]=110></e-column>
              <e-column [width]=80></e-column>
          </e-columns>
      </e-sheet>
  </e-sheets>
</ejs-spreadsheet>`,
})
export class AppComponent {
  @ViewChild('spreadsheet')
  public spreadsheetObj: SpreadsheetComponent | undefined;
  public data: object[] = dataSource;
  public openUrl = 'https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/open';
  public saveUrl = 'https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/save';
  created() {
    this.spreadsheetObj!.cellFormat({ fontWeight: 'bold', textAlign: 'center', verticalAlign: 'middle' }, 'A1:H1');
  };
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Integrating notes during initial loading and using cell data binding

The notes can be added initially when the Spreadsheet loads using cell data binding. You need to use the notes property in the cell settings to add notes to the Spreadsheet.

In the below example, you can navigate between notes using Previous Note and Next Note options, toggle individual note visibility with Show/Hide Note, display all notes at once using Show All Notes and see how notes are added using the updateCell method in the created event.

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { SpreadsheetAllModule } from '@syncfusion/ej2-angular-spreadsheet';

import { Component, ViewChild } from '@angular/core';
import { SpreadsheetComponent } from '@syncfusion/ej2-angular-spreadsheet';
import { dataSource } from './datasource';

@Component({
    imports: [SpreadsheetAllModule],

    standalone: true,
    selector: 'app-container',
    template: `<ejs-spreadsheet #spreadsheet (created)="created()" [openUrl]="openUrl" allowOpen="true" [saveUrl]="saveUrl" allowSave="true">
  <e-sheets>
      <e-sheet name="Price Details">
          <e-ranges>
              <e-range [dataSource]="data"></e-range>
          </e-ranges>
          <e-rows>
          <e-row [index]=2>
            <e-cells>
              <e-cell [index]=0 [notes]="{ text: 'These shoes have the highest sales in terms of quantity this month.', isVisible: true }"></e-cell>
            </e-cells>
          </e-row>
        </e-rows>
          <e-columns>
          <e-column [width]=140></e-column>
              <e-column [width]=110></e-column>
              <e-column [width]=110></e-column>
              <e-column [width]=80></e-column>
          </e-columns>
      </e-sheet>
  </e-sheets>
</ejs-spreadsheet>`,
})
export class AppComponent {
    @ViewChild('spreadsheet')
    public spreadsheetObj: SpreadsheetComponent | undefined;
    public data: object[] = dataSource;
    public openUrl =
        'https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/open';
    public saveUrl =
        'https://document.syncfusion.com/web-services/spreadsheet-editor/api/spreadsheet/save';
    created() {
        this.spreadsheetObj!.cellFormat({ fontWeight: 'bold', textAlign: 'center', verticalAlign: 'middle' }, 'A1:H1');
        this.spreadsheetObj!.updateCell({ notes: { text: 'These shoes have been the most profitable this month.' } }, 'A10:A10');
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Limitations

  • When importing the document with notes, the formatting of the content in the notes will not be available. Similarly, while adding notes, we cannot apply formatting to them.
  • The style and appearance of the dialog box for the notes, including size, color, border, and other elements, cannot be directly changed.
  • Exporting the workbook along with notes is not supported in file formats such as Comma Separated Values (.csv), Excel Macro-Enabled Workbook (.xlsm), Excel Binary Workbook (.xlsb), and PDF Document (.pdf).
  • Notes added outside the used ranges of the worksheet will not be included in the exported document.